package com.zlm.hp.lyrics.utils;

import java.io.File;
import java.text.DecimalFormat;

/**
 * 
 * @author zhangliangming
 * 
 */
public class FileUtils {
	public static String getFileExt(File file) {
		return getFileExt(file.getName());
	}

	public static String removeExt(String s) {
		int index = s.lastIndexOf(".");
		if (index == -1)
			index = s.length();
		return s.substring(0, index);
	}

	public static String getFileExt(String fileName) {
		int pos = fileName.lastIndexOf(".");
		if (pos == -1)
			return "";
		return fileName.substring(pos + 1).toLowerCase();
	}

	/**
	 * 计算文件的大小，返回相关的m字符串
	 * 
	 * @param fileS
	 * @return
	 */
	public static String getFileSize(long fileS) {// 转换文件大小
		DecimalFormat df = new DecimalFormat("#.00");
		String fileSizeString = "";
		if (fileS < 1024) {
			fileSizeString = df.format((double) fileS) + "B";
		} else if (fileS < 1048576) {
			fileSizeString = df.format((double) fileS / 1024) + "K";
		} else if (fileS < 1073741824) {
			fileSizeString = df.format((double) fileS / 1048576) + "M";
		} else {
			fileSizeString = df.format((double) fileS / 1073741824) + "G";
		}
		return fileSizeString;
	}
}
